#include "finddevlock.h"

int FindDeviceLock::testCode(QString code){
    QProcess process;
    QStringList args = QStringList() << "--check-code" << code;
    process.start("/usr/lib/qt5/plugins/devicelock/encpartition", args);
        if (!process.waitForFinished()) {
            //qWarning("Plugin did not finish in time");
            return false;
        }

/*        qDebug() << process.readAllStandardOutput();
        qWarning() << process.readAllStandardError();*/
        return process.exitCode() == 0;
}

int FindDeviceLock::isSet(){
    QProcess process;
    QStringList args = QStringList() << "--is-set" << "lockcode";
    process.start("/usr/lib/qt5/plugins/devicelock/encpartition", args);
        if (!process.waitForFinished()) {
            //qWarning("Plugin did not finish in time");
            return false;
        }

        return process.exitCode() == 0;
}

void FindDeviceLock::locked(){
    emit isset( isSet() != 0);
}

void FindDeviceLock::setSize(int size){
    this->sz = size;
    this->max = 1;
    for(int j=0;j<this->sz;++j){ this->max *= 10;}
}
void FindDeviceLock::incSize(){
    this->sz++;
    this->max = 1;
    for(int j=0;j<this->sz;++j){ this->max *= 10;}
}

void FindDeviceLock::tryCode(int tcode){
    QString code = QString(tcode);
    if(tcode>this->max){
        emit result("over");
        return;
    }

    for(int k=0;(code.length()<this->sz) && (k<10);++k){
        code = "0" + code;
    }
    int out = testCode(code);
    if(out == 1){
        //correct devicelock -> return
        emit result(code);
    }
    //not found :(
    emit result(QString(""));
}


void FindDeviceLock::findCode(int size=5){
    this->setSize(size);
    QString code = "00000";
    for(int i=0;i<(this->max);++i){
        code = QString(i);
        for(int k=0;(code.length()<size) && (k<10);++k){
            code = "0" + code;
            if (size>5){
                if(testCode(code) == 1){
                    //correct devicelock -> return
                    emit result(code);
                }
            }
        }
        emit result(code);
        sleep(1);
        int out = testCode(code);
        if(out == 1){
            //correct devicelock -> return
            emit result(code);
        }
    }
    //not found :(
    emit result(QString(""));
}
